<?php

namespace Drupal\server_ip\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure Server variables settings.
 */
class ServerVariableSettingsForm extends ConfigFormBase {

  /** 
   * Config settings.
   *
   * @var string
   */
  const SETTINGS = 'server_ip.settings';

  /** 
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'server_ip_admin_settings';
  }

  /** 
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      static::SETTINGS,
    ];
  }

  /** 
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    
    $arr_server = $_SERVER;	
    $array_list = array('0' => '-none-');
    foreach ($arr_server as $key=>$value) {      
      $array_list[$key] = $key;
	}
	
	$default = $this->config(static::SETTINGS)->get();
	    
    //Server Variables dropdown
    $form['servervar'] = array(
      '#weight' => '1',
      '#multiple' => TRUE,
      '#type' => 'select',
      '#options' => $array_list,
	  '#title' => 'PHP $_SERVER Variables',
	  '#default_value' => $default,
	  '#description' => 'Please choose the variables to display',
    );

    return parent::buildForm($form, $form_state);
  }

  /** 
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
	// Retrieve the configuration.
	$arr_server = $form_state->getValue('servervar');
	$this->configFactory->getEditable(static::SETTINGS)->delete();	
	$config = $this->configFactory->getEditable(static::SETTINGS);
	
	foreach ($arr_server as $key=>$value) {   	   
      $config->set($key, $value);		
	}
	$config->save();
    parent::submitForm($form, $form_state);
  }

}